package com.dx.easychat.easychatting.controller;


import com.alibaba.fastjson2.JSONObject;
import com.baomidou.mybatisplus.generator.FastAutoGenerator;
import com.baomidou.mybatisplus.generator.engine.FreemarkerTemplateEngine;
import jakarta.annotation.Resource;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.jdbc.DataSourceProperties;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/api/code")
@Log4j2
public class AutoGeneratorController {

    @Resource
    private DataSourceProperties dataSourceProperties;

    @Value("${spring.customer.config.file-path:/opt/file_temp/}")
    private String filePath;

    @GetMapping("/generator")
    @ResponseBody
    public JSONObject generatorCode(@RequestParam String tableName) {
        JSONObject jsonObject = new JSONObject();
        String url = dataSourceProperties.getUrl();
        String username = dataSourceProperties.getUsername();
        String password = dataSourceProperties.getPassword();
        FastAutoGenerator.create(url, username, password)
                .globalConfig(builder -> builder
                        .author("xu.x")
                        .outputDir(filePath)
                        .disableOpenDir()
                        .commentDate("yyyy-MM-dd")
                )
                .packageConfig(builder -> builder
                        .parent("com.dx.easychat.easychatting")
                        .entity("entity")
                        .mapper("mapper")
                        .service("service")
                        .serviceImpl("service.impl")
                        .xml("mapper.xml")
                )
                .strategyConfig(builder ->
                        builder.addInclude(tableName) // 设置需要生成的表名
                                .addTablePrefix("db_") // 设置过滤表前缀
                                .entityBuilder()
                                .enableLombok()
                )
                .templateEngine(new FreemarkerTemplateEngine())
                .execute();
        jsonObject.put("code", "success");
        jsonObject.put("data", null);
        return jsonObject;
    }

}
