package com.dx.easychat.easychatting.controller;

import com.alibaba.fastjson2.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.dx.easychat.easychatting.entity.FileEntity;
import com.dx.easychat.easychatting.entity.Message;
import com.dx.easychat.easychatting.service.FileEntityService;
import com.dx.easychat.easychatting.service.MessageService;
import jakarta.annotation.Resource;
import lombok.extern.log4j.Log4j2;
import org.apache.commons.lang3.StringUtils;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController()
@Log4j2
@RequestMapping("/api/message")
public class MessageController {

    @Resource
    private MessageService messageService;

    @Resource
    private FileEntityService fileEntityService;

    @PostMapping("/config")
    @ResponseBody
    public JSONObject getConfig(@RequestBody JSONObject jsonObject) {
        JSONObject result = new JSONObject();
        String string = jsonObject.getString("id");
        log.info(string);
        int length = string.length();
        log.info(length);
        log.info(jsonObject);
        return result;
    }

    // todo 增加校验webservice的session
    @GetMapping("/get")
    @ResponseBody
    public JSONObject getHistoryMessage() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("code", 200);
        LambdaQueryWrapper<Message> lambdaQueryWrapper = new LambdaQueryWrapper<>();
        lambdaQueryWrapper.eq(Message::getIsDelete, 0);
        List<Message> list = messageService.list(lambdaQueryWrapper);
        for (Message message : list) {
            if ("file".equals(message.getType())) {
                LambdaQueryWrapper<FileEntity> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(FileEntity::getUuid, message.getFile());
                FileEntity fileEntity = fileEntityService.getOne(queryWrapper);
                if (fileEntity != null) {
                    String fileMimeType = fileEntity.getFileMimeType();
                    message.setFileMimeType(fileMimeType);
                    message.setFileName(fileEntity.getFileName());
                }
            }
        }
        jsonObject.put("data", list);
        return jsonObject;
    }

    @GetMapping("/message")
    @ResponseBody
    public JSONObject getMessage(String message_id) {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("code", 200);
        LambdaQueryWrapper<Message> lambdaQueryWrapper = new LambdaQueryWrapper<>();
        lambdaQueryWrapper.eq(Message::getIsDelete, 0);
        if (StringUtils.isNotBlank(message_id)) {
            lambdaQueryWrapper.and(wrapper ->
                    wrapper.eq(Message::getId, message_id).or()
                            .eq(Message::getId, 1));
        }
        List<Message> list = messageService.list(lambdaQueryWrapper);
        for (Message message : list) {
            if ("file".equals(message.getType())) {
                LambdaQueryWrapper<FileEntity> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(FileEntity::getUuid, message.getFile());
                List<FileEntity> fileEntityList = fileEntityService.list(queryWrapper);
                if (fileEntityList != null) {
                    message.setFileEntityList(fileEntityList);
                }
            }
        }
        jsonObject.put("data", list);
        return jsonObject;
    }

}
