package com.dx.easychat.easychatting.cron;

import com.dx.easychat.easychatting.mapper.FileEntityMapper;
import jakarta.annotation.Resource;
import lombok.extern.log4j.Log4j2;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.File;
import java.util.List;

/**
 * 定时任务：每五分钟执行一次
 * 查询出已经到达过期时间的数据，删除物理文件同时更新回表单
 */
@Component
@Log4j2
public class DeleteFileCronJob {

    @Resource
    FileEntityMapper fileEntityMapper;

    @Scheduled(cron ="0 0/5 * * * ?")
    public void executeCronJob() {
        List<String> allDeleteFilePath = fileEntityMapper.findAllDeleteFilePath();
        for (String filePath : allDeleteFilePath) {
            File file = new File(filePath);
            if (file.exists()) {
                file.delete();
            }
        }
    }

}
