package com.dx.easychat.easychatting.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;
import lombok.extern.log4j.Log4j2;

import java.util.Date;
import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
@ToString
@Log4j2
@TableName("db_message")
public class Message {

    @TableId(type = IdType.AUTO)
    private Integer id;

    private String content;

    private Date time;

    private String type;

    private String file;

    private Integer isDelete;

    @JsonProperty(access = JsonProperty.Access.WRITE_ONLY)
    private String ip;

    @TableField(exist = false)
    private String sessionId;

    @TableField(exist = false)
    private String messageType;

    @TableField(exist = false)
    private String fileName;

    @TableField(exist = false)
    private String fileMimeType;

    @TableField(exist = false)
    private List<FileEntity> fileEntityList;

}
