package com.dx.easychat.easychatting.entity.vo.request;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * 前端请求的发送offer参数实体类
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class SendOfferEntity {

    /**
     * 是否快速入职
     */
    private Integer isFastIn;

    /**
     * 是否快速入职
     */
    private Integer isUploadMedicalReport;

    /**
     * 是否短信通知
     */
    private Boolean isMessageNotice;

    /**
     * 短信内容
     */
    private String messageContent;

    /**
     * 是否邮件通知
     */
    private Boolean isEmailNotice;

    /**
     * 邮件标题
     */
    private String emailTitle;

    /**
     * 邮件内容
     */
    private String emailContent;

    /**
     * 选中的行ID 以逗号分隔
     */
    private String ids;

    /**
     * 入职须知（文件上传）
     */
    private List<MultipartFile> file;


    @Override
    public String toString() {
        return "SendOfferEntity{" +
                "isFastIn=" + isFastIn +
                ", \nisUploadMedicalReport=" + isUploadMedicalReport +
                ", \nisMessageNotice=" + isMessageNotice +
                ", \nmessageContent='" + messageContent + '\'' +
                ", \nisEmailNotice=" + isEmailNotice +
                ", \nemailTitle='" + emailTitle + '\'' +
                ", \nemailContent='" + emailContent + '\'' +
                ", \nids='" + ids + '\'' +
                ", \nfile=" + file +
                '}';
    }
}
